// Code generated by SQLBoiler 3.5.0 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testUserRecipes(t *testing.T) {
	t.Parallel()

	query := UserRecipes()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testUserRecipesDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testUserRecipesQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := UserRecipes().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testUserRecipesSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := UserRecipeSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testUserRecipesExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := UserRecipeExists(ctx, tx, o.UserID, o.RecipeID)
	if err != nil {
		t.Errorf("Unable to check if UserRecipe exists: %s", err)
	}
	if !e {
		t.Errorf("Expected UserRecipeExists to return true, but got false.")
	}
}

func testUserRecipesFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	userRecipeFound, err := FindUserRecipe(ctx, tx, o.UserID, o.RecipeID)
	if err != nil {
		t.Error(err)
	}

	if userRecipeFound == nil {
		t.Error("want a record, got nil")
	}
}

func testUserRecipesBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = UserRecipes().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testUserRecipesOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := UserRecipes().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testUserRecipesAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	userRecipeOne := &UserRecipe{}
	userRecipeTwo := &UserRecipe{}
	if err = randomize.Struct(seed, userRecipeOne, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}
	if err = randomize.Struct(seed, userRecipeTwo, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = userRecipeOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = userRecipeTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := UserRecipes().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testUserRecipesCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	userRecipeOne := &UserRecipe{}
	userRecipeTwo := &UserRecipe{}
	if err = randomize.Struct(seed, userRecipeOne, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}
	if err = randomize.Struct(seed, userRecipeTwo, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = userRecipeOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = userRecipeTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func userRecipeBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func userRecipeAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *UserRecipe) error {
	*o = UserRecipe{}
	return nil
}

func testUserRecipesHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &UserRecipe{}
	o := &UserRecipe{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, userRecipeDBTypes, false); err != nil {
		t.Errorf("Unable to randomize UserRecipe object: %s", err)
	}

	AddUserRecipeHook(boil.BeforeInsertHook, userRecipeBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	userRecipeBeforeInsertHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.AfterInsertHook, userRecipeAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	userRecipeAfterInsertHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.AfterSelectHook, userRecipeAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	userRecipeAfterSelectHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.BeforeUpdateHook, userRecipeBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	userRecipeBeforeUpdateHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.AfterUpdateHook, userRecipeAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	userRecipeAfterUpdateHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.BeforeDeleteHook, userRecipeBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	userRecipeBeforeDeleteHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.AfterDeleteHook, userRecipeAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	userRecipeAfterDeleteHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.BeforeUpsertHook, userRecipeBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	userRecipeBeforeUpsertHooks = []UserRecipeHook{}

	AddUserRecipeHook(boil.AfterUpsertHook, userRecipeAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	userRecipeAfterUpsertHooks = []UserRecipeHook{}
}

func testUserRecipesInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testUserRecipesInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(userRecipeColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testUserRecipeToOneUserUsingUser(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local UserRecipe
	var foreign User

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, userDBTypes, false, userColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize User struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.UserID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.User().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := UserRecipeSlice{&local}
	if err = local.L.LoadUser(ctx, tx, false, (*[]*UserRecipe)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.User == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.User = nil
	if err = local.L.LoadUser(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.User == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testUserRecipeToOneRecipeUsingRecipe(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local UserRecipe
	var foreign Recipe

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, userRecipeDBTypes, false, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, recipeDBTypes, false, recipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Recipe struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.RecipeID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Recipe().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := UserRecipeSlice{&local}
	if err = local.L.LoadRecipe(ctx, tx, false, (*[]*UserRecipe)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Recipe == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Recipe = nil
	if err = local.L.LoadRecipe(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Recipe == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testUserRecipeToOneSetOpUserUsingUser(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a UserRecipe
	var b, c User

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, userRecipeDBTypes, false, strmangle.SetComplement(userRecipePrimaryKeyColumns, userRecipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, userDBTypes, false, strmangle.SetComplement(userPrimaryKeyColumns, userColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, userDBTypes, false, strmangle.SetComplement(userPrimaryKeyColumns, userColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*User{&b, &c} {
		err = a.SetUser(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.User != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.UserRecipes[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.UserID != x.ID {
			t.Error("foreign key was wrong value", a.UserID)
		}

		if exists, err := UserRecipeExists(ctx, tx, a.UserID, a.RecipeID); err != nil {
			t.Fatal(err)
		} else if !exists {
			t.Error("want 'a' to exist")
		}

	}
}
func testUserRecipeToOneSetOpRecipeUsingRecipe(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a UserRecipe
	var b, c Recipe

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, userRecipeDBTypes, false, strmangle.SetComplement(userRecipePrimaryKeyColumns, userRecipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, recipeDBTypes, false, strmangle.SetComplement(recipePrimaryKeyColumns, recipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, recipeDBTypes, false, strmangle.SetComplement(recipePrimaryKeyColumns, recipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Recipe{&b, &c} {
		err = a.SetRecipe(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Recipe != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.UserRecipes[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.RecipeID != x.ID {
			t.Error("foreign key was wrong value", a.RecipeID)
		}

		if exists, err := UserRecipeExists(ctx, tx, a.UserID, a.RecipeID); err != nil {
			t.Fatal(err)
		} else if !exists {
			t.Error("want 'a' to exist")
		}

	}
}

func testUserRecipesReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testUserRecipesReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := UserRecipeSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testUserRecipesSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := UserRecipes().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	userRecipeDBTypes = map[string]string{`UserID`: `int`, `RecipeID`: `int`, `IsFavourited`: `tinyint`, `IsBanned`: `tinyint`, `Count`: `int`}
	_                 = bytes.MinRead
)

func testUserRecipesUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(userRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(userRecipeAllColumns) == len(userRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testUserRecipesSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(userRecipeAllColumns) == len(userRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &UserRecipe{}
	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, userRecipeDBTypes, true, userRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(userRecipeAllColumns, userRecipePrimaryKeyColumns) {
		fields = userRecipeAllColumns
	} else {
		fields = strmangle.SetComplement(
			userRecipeAllColumns,
			userRecipePrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := UserRecipeSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testUserRecipesUpsert(t *testing.T) {
	t.Parallel()

	if len(userRecipeAllColumns) == len(userRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}
	if len(mySQLUserRecipeUniqueColumns) == 0 {
		t.Skip("Skipping table with no unique columns to conflict on")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := UserRecipe{}
	if err = randomize.Struct(seed, &o, userRecipeDBTypes, false); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert UserRecipe: %s", err)
	}

	count, err := UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, userRecipeDBTypes, false, userRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize UserRecipe struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert UserRecipe: %s", err)
	}

	count, err = UserRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
